# get_password.rb
# Simple function to get a password from a XML. The XML must be have generated by windows_ad module
#
# Created by Jerome RIVIERE (www.jerome-riviere.re) (https://github.com/ninja-2)
require "puppet"

module Puppet::Parser::Functions
  newfunction(:get_password, :type => :rvalue, :doc => <<-EOS
return a password from the users.xml generated by jriviere/windows_ad module.
    EOS
  ) do |args|
    raise(Puppet::ParseError, "get_password(): Wrong number of arguments " +
      "given (#{args.size} for 2)") if args.size != 2
    require 'rexml/document'
    if (File.size?(args[1]) != nil)
      file = File.new(args[1])
      doc = REXML::Document.new file
      root = doc.root
      users = root.elements["users"]
      users.elements.map do | user |
        if (user.attributes['name'] == args[0])
          if(user.attributes['password'].empty?)
            raise(Puppet::ParseError, "get_password(): Cant get the password from the xml file. You need to fill a password in xml or use the variable in your manifest.")
          else
            return user.attributes['password']
          end
        end
      end
      raise(Puppet::ParseError, "get_password(): Cant get the password from the xml file. You need to fill a password in xml or use the variable in your manifest.")
    end
  end
end
